// Servo Sg-90 test by Servo library

#include <Servo.h> 

#define LED_STATUS                13
#define SERVO_PIN                 11

#define MY_MIN_PULSE_WIDTH       590     // the shortest pulse sent to a servo
#define MY_MAX_PULSE_WIDTH      2560     // the longest pulse sent to a servo

Servo myservo;  // create servo object to control a servo 

int current_angle = 0;          // servo current angle
int current_microsecond = 0;    // servo current pulse width
 
void setup() 
{ 
  pinMode(LED_STATUS, OUTPUT);
  
  Serial.begin(9600);
  Serial.println("Servo Ready");
  
  myservo.attach(SERVO_PIN, MY_MIN_PULSE_WIDTH, MY_MAX_PULSE_WIDTH);  // attaches the servo to the servo object
} 
 
void loop() 
{ 
  int index1 = 0;
  int index2 = 0;
  
  digitalWrite(LED_STATUS, HIGH);

  for(index1 = 0; index1 < 181; index1+=1)        // start and end - angle
  //for(index1 = 590; index1 < 2450; index1+=20)  // start - microseconds
  //for(index1 = 2300; index1 < 2560; index1+=2)  // end - microseconds
  {
    for(index2 = 0; index2 < 2; index2++)
    {
      myservo.write(index1);               // sets the servo position according to the scaled value
      //myservo.writeMicroseconds(index1); // Write pulse width in microseconds
      delay(15);                           // waits for the servo to get there
    }
    
    current_angle = 0;
    //current_microsecond = 0;
    
    current_angle = myservo.read();                        // returns current pulse width as an angle between 0 and 180 degrees
    //current_microsecond = myservo.readMicroseconds();            // returns current pulse width in microseconds for this servo (was read_us() in first release)

    Serial.print("write: ");
    Serial.print(index1);
    Serial.print(", read: ");
    Serial.print(current_angle);
    //Serial.print(current_microsecond);
    Serial.println(" degree");
    //Serial.println(" micro second");
  }
 
  digitalWrite(LED_STATUS,LOW);
  
  delay(500);                           // waits for the servo to get there
  
} 

